<template>
  <div class="auth-v1">
    <b-row class="m-0 p-0">
      <!-- Login v1 -->
      <b-col lg="6" class="p-0">
        <div
          :style="{ 'background-image': 'url(' + bgImgOne + ')' }"
          class="login-bg"
        ></div>
      </b-col>
      <b-col lg="6" class="d-flex align-items-center auth-bg">
        <div class="auth-wrapper auth-v1 px-2">
          <div class="auth-inner p-0">
            <!-- Login v1 -->
            <b-card class="mb-0 py-1">
              <b-card-text class="text-left">
                <b-link :to="{ name: 'login' }">
                  <FeatherIcon icon="ArrowLeftIcon" /> Back to Login
                </b-link>
              </b-card-text>
              <!-- form -->
              <div class="py-2">
                <b-card-title class="mb-1"> Reset Password</b-card-title>
                  <b-form class="auth-login-form mt-2" @submit.prevent="login">
                    <!-- email -->
                    <b-form-group label="Password" label-for="forgot-password">
                      <b-input-group
                          class="input-group-merge"
                          :class="errors.length > 0 ? 'is-invalid' : null"
                        >
                          <b-form-input
                            id="forgot-password"
                            v-model="password"
                            :state="errors.length > 0 ? false : null"
                            class="form-control-merge"
                            :type="passwordFieldType"
                            name="forgot-password"
                            placeholder="Enter New Password"
                          />
                          <b-input-group-append is-text @click="togglePasswordVisibility">
                            <svg xmlns="http://www.w3.org/2000/svg" v-if="passwordFieldType === 'password'"  width="14px" height="14px" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-eye-off cursor-pointer" size="14px"><path d="M17.94 17.94A10.07 10.07 0 0 1 12 20c-7 0-11-8-11-8a18.45 18.45 0 0 1 5.06-5.94M9.9 4.24A9.12 9.12 0 0 1 12 4c7 0 11 8 11 8a18.5 18.5 0 0 1-2.16 3.19m-6.72-1.07a3 3 0 1 1-4.24-4.24"></path><line x1="1" y1="1" x2="23" y2="23"></line></svg>
                            <svg xmlns="http://www.w3.org/2000/svg" v-if="passwordFieldType != 'password'" width="14px" height="14px" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-eye cursor-pointer" size="14px"><path d="M1 12s4-8 11-8 11 8 11 8-4 8-11 8-11-8-11-8z"></path><circle cx="12" cy="12" r="3"></circle></svg>
                          </b-input-group-append>
                        </b-input-group>
                        <small class="text-danger">{{ errors[0] }}</small>
                      </b-form-group>

                    <b-form-group label="Confirm Password" label-for="confirm-password">
                        <b-input-group
                          class="input-group-merge"
                          :class="errors.length > 0 ? 'is-invalid' : null"
                        >
                          <b-form-input
                            id="confirm-password"
                            v-model="cpassword"
                            :state="errors.length > 0 ? false : null"
                            class="form-control-merge"
                            :type="passwordFieldType"
                            name="confirm-password"
                            placeholder="Enter Confirm Password"
                          />
                          <b-input-group-append is-text  @click="togglePasswordVisibility">
                            <svg xmlns="http://www.w3.org/2000/svg" v-if="passwordFieldType === 'password'"  width="14px" height="14px" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-eye-off cursor-pointer" size="14px"><path d="M17.94 17.94A10.07 10.07 0 0 1 12 20c-7 0-11-8-11-8a18.45 18.45 0 0 1 5.06-5.94M9.9 4.24A9.12 9.12 0 0 1 12 4c7 0 11 8 11 8a18.5 18.5 0 0 1-2.16 3.19m-6.72-1.07a3 3 0 1 1-4.24-4.24"></path><line x1="1" y1="1" x2="23" y2="23"></line></svg>
                            <svg xmlns="http://www.w3.org/2000/svg" v-if="passwordFieldType != 'password'" width="14px" height="14px" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-eye cursor-pointer" size="14px"><path d="M1 12s4-8 11-8 11 8 11 8-4 8-11 8-11-8-11-8z"></path><circle cx="12" cy="12" r="3"></circle></svg>
                          </b-input-group-append>
                        </b-input-group>
                        <small class="text-danger">{{ errors[0] }}</small>
                    </b-form-group>

                    <!-- submit buttons -->
                    <b-button type="submit" variant="primary" block :disabled="isSubmit">
                      <b-spinner small v-if="isSubmit" />
                      Submit
                    </b-button>
                  </b-form>
                </div>
            </b-card>
            <!-- /Login v1 -->
          </div>
        </div>
      </b-col>
      <!-- /Login v1 -->
    </b-row>
  </div>
</template>

<script>
import {
  BRow,
  BImg,
  BCol,
  BButton,
  BForm,
  BFormInput,
  BFormGroup,
  BCard,
  BLink,
  BCardTitle,
  BCardText,
  BInputGroup,
  BInputGroupAppend,
  BFormCheckbox,
  BAlert,
  BSpinner,
} from "bootstrap-vue";
import VuexyLogo from "@core/layouts/components/Logo.vue";
import Auth from "@/apis/Auth";
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import { togglePasswordVisibility } from "@core/mixins/ui/forms";
import router from "@/router";
import { useToast } from "vue-toastification";
const toast = useToast();
export default {
  components: {
    // BSV
    BRow,
    BImg,
    BCol,
    BButton,
    BForm,
    BFormInput,
    BFormGroup,
    BCard,
    BCardTitle,
    BLink,
    VuexyLogo,
    BCardText,
    BInputGroup,
    BInputGroupAppend,
    BFormCheckbox,
    BAlert,
    BSpinner,
  },
  mixins: [togglePasswordVisibility],

  computed: {
    passwordToggleIcon() {
      return this.passwordFieldType === "password" ? "EyeIcon" : "EyeOffIcon";
    },
  },
  data() {
    const { appVersion , appLogoImage, bgImgOne} = $themeConfig.app;
    return {
      bgImgOne,
      password: "",
      cpassword: "",
      required,
      email,
      isSubmit: false,
    };
  },
  methods: {
    login() {
      // this.$refs.setPasswordForm.validate().then((success) => {
        if (true) {
          this.isSubmit = true;
          Auth.setPassword({
            token: router.currentRoute.params.token,
            password: this.password,
            confirm_password: this.cpassword,
          })
            .then((response) => {
              const data = response.data;
              if (response.data.status == true) {
                this.isSubmit = false;
                this.$router
                  .push({
                    name: "login",
                  })
                  .then(() => {
                    toast({
                      component: ToastificationContent,
                      props: {
                        variant: "success",
                        icon: "CheckCircleIcon",
                        title: data.title,
                        text: data.message,
                      },
                    });
                  });
              } else {
                if (data.errors) {
                  this.$refs.setPasswordForm.setErrors(data.errors);
                } else {
                  toast({
                    component: ToastificationContent,
                    props: {
                      title: data.title,
                      icon: "AlertCircleIcon",
                      text: data.message,
                      variant: "danger",
                    },
                  });
                }
                this.isSubmit = false;
              }
            })
            .catch((error) => {
              toast({
                component: ToastificationContent,
                props: {
                  title: "Error",
                  icon: "AlertCircleIcon",
                  text: "Something went wrong. Please try later.",
                  variant: "danger",
                },
              });
              this.isSubmit = false;
            });
        }
      // });
    },
  },
};
</script>

<style lang="scss">
@import "~@resources/scss/vue/pages/page-auth.scss";
.auth-v1 {
    .login-bg {
      height: 100%;
      background-size: cover;
    }
    .auth-inner {
    }
  }
  .brand-logo {
    display: flex;
    justify-content: center;
  }
</style>
